=== debian/changelog ===
gnuradio (3.7.13.4-4+rb2) UNRELEASED; urgency=medium

  * update

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 22 Jan 2021 11:20:31 +0800

gnuradio (3.7.13.4-4) unstable; urgency=medium

  * more hurd-i386 build fixes. Thanks again, Samuel! (Closes: #918481)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 06 Jan 2019 20:12:41 -0500

gnuradio (3.7.13.4-3) unstable; urgency=medium

  * update to v3.7.13.4-5-g556c511fc3
  * improve hurd-i386 build. Thanks Samuel! (Closes: #918481)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 06 Jan 2019 11:19:49 -0500

gnuradio (3.7.13.4-2) unstable; urgency=high

  * update to v3.7.13.4-2-gbd159f5ce3
  * gnuradio-companion and grcc still requires python-gtk2
    (Closes: #902371, #910001)

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 08 Nov 2018 17:22:38 -0500

gnuradio (3.7.13.4-1) unstable; urgency=medium

  * New upstream release
  * Fix Boost 1.67 linking issue
  * gnuradio-runtime
    - Logging: fixed issues where messages weren't properly written
    to stdout/stderr due to incorrect strings
  * gr-analog fmdet_cf's derivative coefficients were wrong.
  * gr-blocks skiphead used to incorrectly handle tags, now properly shifts
  * gr-digital qa_packet_format: Unit test used to potentially lock up due
    to incorrect conditionals
    clock_recovery_cc, crc32_bb: Accessing the `[0]` element of an empty
    vector is UB, even if you don't use the result afterwards.
  * gr-fec polar_encoder/_common: Fixed multiple out-of-bound accesses
    due to insufficient vector length checks
  * gr-filter fft_filter, filter_delay: Accessing the `[0]` element
    of an empty vector is UB, even if you don't use the result afterwards.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 16 Jul 2018 21:09:14 -0400
